<!doctype html>
<html class="no-js">
<head>



<meta charset="utf-8">
<title>Learn Python the Hard Way</title>

<meta http-equiv="X-UA-Compatible" content="IE=edge">
<meta name="description" content="">
<meta name="viewport" content="width=device-width,initial-scale=1">

<link href='https://fonts.googleapis.com/css?family=Source+Code+Pro|Source+Sans+Pro:200,400,700,200italic,400italic,700italic' rel='stylesheet' type='text/css'>
<link href="../css/style.min.css" rel="stylesheet">
<!-- http://www.socicon.com -->
<link href="../css/icons.css" rel="stylesheet">


</head>

<body class="baseline-grid-off book-site" id="top">




<header class="header" role="banner">
    <nav class="navbar navbar-full nav-brand-family">
        <div class="row middle-xs">
            <ul class="brand-links show-md col-xs-3 col-sm-10 bare">
                <li><a href="https://learncodethehardway.org" class="waves-effect">Learn:</a></li>

                <li><a href="https://learncodethehardway.org/python/" class="waves-effect active">Python</a></li>

                <li><a href="https://learncodethehardway.org/ruby/" class="waves-effect">Ruby</a></li>

                <li><a href="https://learncodethehardway.org/more-python/" class="waves-effect">More Python</a></li>

                <li><a href="https://learncodethehardway.org/c/" class="waves-effect">C</a></li>

                <li><a href="https://learncodethehardway.org/sql/" class="waves-effect">SQL</a></li>

                <li><a href="https://learncodethehardway.org/javascript/" class="waves-effect">Javascript</a></li>

                <li><a href="https://learncodethehardway.org/unix/" class="waves-effect">Unix</a></li>

                <li><a href="https://learncodethehardway.org/regex/" class="waves-effect">RegEx</a></li>

                <li><a href="https://www.learndesignthehardway.com/" class="waves-effect">Design</a></li>

            </ul>
            <ul class="brand-links hide-md col-xs-3 col-sm-10 bare">
                <li><a href="https://learncodethehardway.org/" class="waves-effect">LCTHW</a></li>
            </ul>

            <ul class="site-meta col-xs-9 col-sm-2 end-xs bare">
                <li><a href="https://shop.learncodethehardway.org/access/reactivate/" class="waves-effect"><i class="icon icon-user"></i> Login</a></li>
            </ul>

        </div>
    </nav>

    <nav class="navbar navbar-full nav-main" role="navigation">
        <div class="row between-xs center-xs middle-xs bare">
            <div class="col-xs-4 start-xs bare">
                <a href="ex33.html#" class="no-underline nav-trigger waves-effect" id="toc"><div class="transformer hamburcloser">
                        <div class="bar bar-t"></div>
                        <div class="bar bar-m-a"></div>
                        <div class="bar bar-m-b"></div>
                        <div class="bar bar-b"></div>
                </div><span class="nav-trigger_text show-sm-inline">Contents</span></a>
            </div>
            <div class="col-xs-4"><strong>&nbsp;</strong></div>
            <div class="col-xs-4 end-xs bare">
                <a href="https://helpthw.zendesk.com/hc/en-us" class="no-underline nav-trigger waves-effect" id="help"><div class="transformer questioncloser">
                        <div class="icon-question-mark"></div>
                </div><span class="nav-trigger_text show-sm-inline">Help</span></a>
            </div>
        </div>
    </nav>

</header>




<div class="wrapper">
    <div class="masthead python-background" style="background-image: url('/images/pattern-python.svg')">
        <img src="../images/logo-python.svg" alt="Learn Python The Hard Way" class="logo">
    </div>

    <aside class="sidebar sidebar-left" role="complementary">
        <nav class="side-nav-container">
            <ol class="table-of-contents">
                <h3>Table of Contents</h3>
                <li><a href="preface.html">Preface</a></li>
                <li><a href="intro.html">The Hard Way Is Easier</a></li>
                <li><a href="ex0.html">Ex0: The Setup</a></li>
                <li><a href="ex1.html">Ex1: A Good First Program</a></li>
                <li><a href="ex2.html">Ex2: Comments And Pound Characters</a></li>
                <li><a href="ex3.html">Ex3: Numbers And Math</a></li>
                <li><a href="ex4.html">Ex4: Variables And Names</a></li>
                <li><a href="ex5.html">Ex5: More Variables And Printing</a></li>
                <li><a href="ex6.html">Ex6: Strings And Text</a></li>
                <li><a href="ex7.html">Ex7: More Printing</a></li>
                <li><a href="ex8.html">Ex8: Printing, Printing</a></li>
                <li><a href="ex9.html">Ex9: Printing, Printing, Printing</a></li>
                <li><a href="ex10.html">Ex10: What Was That?</a></li>
                <li><a href="ex11.html">Ex11: Asking Questions</a></li>
                <li><a href="ex12.html">Ex12: Prompting People</a></li>
                <li><a href="ex13.html">Ex13: Parameters, Unpacking, Variables</a></li>
                <li><a href="ex14.html">Ex14: Prompting And Passing</a></li>
                <li><a href="ex15.html">Ex15: Reading Files</a></li>
                <li><a href="ex16.html">Ex16: Reading And Writing Files</a></li>
                <li><a href="ex17.html">Ex17: More Files</a></li>
                <li><a href="ex18.html">Ex18: Names, Variables, Code, Functions</a></li>
                <li><a href="ex19.html">Ex19: Functions And Variables</a></li>
                <li><a href="ex20.html">Ex20: Functions And Files</a></li>
                <li><a href="ex21.html">Ex21: Functions Can Return Something</a></li>
                <li><a href="ex22.html">Ex22: What Do You Know So Far?</a></li>
                <li><a href="ex23.html">Ex23: Read Some Code</a></li>
                <li><a href="ex24.html">Ex24: More Practice</a></li>
                <li><a href="ex25.html">Ex25: Even More Practice</a></li>
                <li><a href="ex26.html">Ex26: Congratulations, Take A Test!</a></li>
                <li><a href="ex27.html">Ex27: Memorizing Logic</a></li>
                <li><a href="ex28.html">Ex28: Boolean Practice</a></li>
                <li><a href="ex29.html">Ex29: What If</a></li>
                <li><a href="ex30.html">Ex30: Else And If</a></li>
                <li><a href="ex31.html">Ex31: Making Decisions</a></li>
                <li><a href="ex32.html">Ex32: Loops And Lists</a></li>
                <li><a href="ex33.html">Ex33: While Loops</a></li>
                <li><a href="ex34.html">Ex34: Accessing Elements Of Lists</a></li>
                <li><a href="ex35.html">Ex35: Branches and Functions</a></li>
                <li><a href="ex36.html">Ex36: Designing and Debugging</a></li>
                <li><a href="ex37.html">Ex37: Symbol Review</a></li>
                <li><a href="ex38.html">Ex38: Doing Things To Lists</a></li>
                <li><a href="ex39.html">Ex39: Dictionaries, Oh Lovely Dictionaries</a></li>
                <li><a href="ex40.html">Ex40: Modules, Classes, And Objects</a></li>
                <li><a href="ex41.html">Ex41: Learning To Speak Object Oriented</a></li>
                <li><a href="ex42.html">Ex42: Is-A, Has-A, Objects, and Classes</a></li>
                <li><a href="ex43.html">Ex43: Gothons From Planet Percal #25</a></li>
                <li><a href="ex44.html">Ex44: Inheritance Vs. Composition</a></li>
                <li><a href="ex45.html">Ex45: You Make A Game</a></li>
                <li><a href="ex46.html">Ex46: A Project Skeleton</a></li>
                <li><a href="ex47.html">Ex47: Automated Testing</a></li>
                <li><a href="ex48.html">Ex48: Advanced User Input</a></li>
                <li><a href="ex49.html">Ex49: Making Sentences</a></li>
                <li><a href="ex50.html">Ex50: Your First Website</a></li>
                <li><a href="ex51.html">Ex51: Getting Input From A Browser</a></li>
                <li><a href="ex52.html">Ex52: The Start Of Your Web Game</a></li>
                <li><a href="advice.html">Advice From An Old Programmer</a></li>
                <li><a href="next.html">Next Steps</a></li>
                <li><a href="appendixa.html">Appendix A: Command Line Crash Course</a></li>
            </ol>
            <ul class="site-links">
                <h3>Learn the Hard Way</h3>
                <li><a href="ex33.html#" class="waves-effect"><i class="icon-information"></i> About LPTHW</a></li>
                <li><a href="ex33.html#" class="waves-effect"><i class="icon-question-mark"></i> Help &amp; Support</a></li>
                <li><a href="ex33.html#" class="waves-effect"><i class="socicon-twitter"></i> Follow us on Twitter</a></li>
            </ul>
        </nav>
        <div class="colophon text-center">
            <div class="intro">
                <p class="bare-bottom">
                The type for this book is set in 18px / 1.5
                <a href="https://www.google.com/fonts/specimen/Source+Serif+Pro">Adobe Serif</a>,
                <a href="https://www.google.com/fonts/specimen/Source+Sans+Pro">Sans</a>, and
                <a href="https://www.google.com/fonts/specimen/Source+Code+Pro">Code</a>.
                </p>
            </div>
            <div class="printers-mark">
                <div class="inscription">Docendo <i class="icon-repeat"></i> Discimus</div>
            </div>
        </div>
    </aside>

    <div class="overlay"></div>

    <main class="main python" role="main">
    <div class="main-container row center-xs">
        <div class="col-xs-11 col-sm-10 col-md-9 col-lg-8">

            <div class="content">
                <!--- RST STARTS -->
                <h1 class="title">Exercise 33: While Loops</h1>
                <p>Now to totally blow your mind with a new loop, the <tt class="docutils literal"><span class="pre">while-loop</span></tt>.  A <tt class="docutils literal"><span class="pre">while-loop</span></tt> will keep executing the code block under it as long as a boolean expression is <tt class="docutils literal">True</tt>.</p>
<p>Wait, you have been keeping up with the terminology, right?  That if we write a line and end it with a <tt class="docutils literal">:</tt> (colon) then that tells Python to start a new block of code?  Then we indent and that's the new code.  This is all about structuring your programs so that Python knows what you mean.  If you do not get that idea then go back and do some more work with <tt class="docutils literal"><span class="pre">if-statements</span></tt>, functions, and the <tt class="docutils literal"><span class="pre">for-loop</span></tt> until you get it.</p>
<p>Later on we'll have some exercises that will train your brain to read these structures, similar to how we burned boolean expressions into your brain.</p>
<p>Back to <tt class="docutils literal"><span class="pre">while-loops</span></tt>. What they do is simply do a test like an <tt class="docutils literal"><span class="pre">if-statement</span></tt>, but instead of running the code block <em>once</em>, they jump back to the &quot;top&quot; where the <tt class="docutils literal">while</tt> is, and repeat.  A <tt class="docutils literal"><span class="pre">while-loop</span></tt> runs until the expression is <tt class="docutils literal">False</tt>.</p>
<p>Here's the problem with <tt class="docutils literal"><span class="pre">while-loops</span></tt>: Sometimes they do not stop. This is great if your intention is to just keep looping until the end of the universe.  Otherwise you almost always want your loops to end eventually.</p>
<p>To avoid these problems, there are some rules to follow:</p>
<ol class="arabic simple">
<li>Make sure that you use <tt class="docutils literal"><span class="pre">while-loops</span></tt> sparingly.  Usually a <tt class="docutils literal"><span class="pre">for-loop</span></tt> is better.</li>
<li>Review your while statements and make sure that the boolean test will become <tt class="docutils literal">False</tt> at some point.</li>
<li>When in doubt, print out your test variable at the top and bottom of the <tt class="docutils literal"><span class="pre">while-loop</span></tt> to see what it's doing.</li>
</ol>
<p>In this exercise, you will learn the <tt class="docutils literal"><span class="pre">while-loop</span></tt> while doing these three checks:</p>
<table class="highlighttable"><tr><td class="linenos"><div class="linenodiv"><pre> 1
 2
 3
 4
 5
 6
 7
 8
 9
10
11
12
13
14
15
16</pre></div></td><td class="code"><div class="highlight"><pre><span></span><a name="python--ex33.py-idio.html-1"></a><span class="n">i</span> <span class="o">=</span> <span class="mi">0</span>
<a name="python--ex33.py-idio.html-2"></a><span class="n">numbers</span> <span class="o">=</span> <span class="p">[]</span>
<a name="python--ex33.py-idio.html-3"></a>
<a name="python--ex33.py-idio.html-4"></a><span class="k">while</span> <span class="n">i</span> <span class="o">&lt;</span> <span class="mi">6</span><span class="p">:</span>
<a name="python--ex33.py-idio.html-5"></a>    <span class="k">print</span> <span class="s2">&quot;At the top i is </span><span class="si">%d</span><span class="s2">&quot;</span> <span class="o">%</span> <span class="n">i</span>
<a name="python--ex33.py-idio.html-6"></a>    <span class="n">numbers</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">i</span><span class="p">)</span>
<a name="python--ex33.py-idio.html-7"></a>
<a name="python--ex33.py-idio.html-8"></a>    <span class="n">i</span> <span class="o">=</span> <span class="n">i</span> <span class="o">+</span> <span class="mi">1</span>
<a name="python--ex33.py-idio.html-9"></a>    <span class="k">print</span> <span class="s2">&quot;Numbers now: &quot;</span><span class="p">,</span> <span class="n">numbers</span>
<a name="python--ex33.py-idio.html-10"></a>    <span class="k">print</span> <span class="s2">&quot;At the bottom i is </span><span class="si">%d</span><span class="s2">&quot;</span> <span class="o">%</span> <span class="n">i</span>
<a name="python--ex33.py-idio.html-11"></a>
<a name="python--ex33.py-idio.html-12"></a>
<a name="python--ex33.py-idio.html-13"></a><span class="k">print</span> <span class="s2">&quot;The numbers: &quot;</span>
<a name="python--ex33.py-idio.html-14"></a>
<a name="python--ex33.py-idio.html-15"></a><span class="k">for</span> <span class="n">num</span> <span class="ow">in</span> <span class="n">numbers</span><span class="p">:</span>
<a name="python--ex33.py-idio.html-16"></a>    <span class="k">print</span> <span class="n">num</span>
</pre></div>
</td></tr></table><div class="section" id="what-you-should-see">
<h1>What You Should See</h1>
<div class="highlight"><pre><span></span><a name="python--ex33.sh-idio-shint-pyg.html-1"></a><span class="gp">$</span> python ex33.py
<a name="python--ex33.sh-idio-shint-pyg.html-2"></a><span class="go">At the top i is 0</span>
<a name="python--ex33.sh-idio-shint-pyg.html-3"></a><span class="go">Numbers now:  [0]</span>
<a name="python--ex33.sh-idio-shint-pyg.html-4"></a><span class="go">At the bottom i is 1</span>
<a name="python--ex33.sh-idio-shint-pyg.html-5"></a><span class="go">At the top i is 1</span>
<a name="python--ex33.sh-idio-shint-pyg.html-6"></a><span class="go">Numbers now:  [0, 1]</span>
<a name="python--ex33.sh-idio-shint-pyg.html-7"></a><span class="go">At the bottom i is 2</span>
<a name="python--ex33.sh-idio-shint-pyg.html-8"></a><span class="go">At the top i is 2</span>
<a name="python--ex33.sh-idio-shint-pyg.html-9"></a><span class="go">Numbers now:  [0, 1, 2]</span>
<a name="python--ex33.sh-idio-shint-pyg.html-10"></a><span class="go">At the bottom i is 3</span>
<a name="python--ex33.sh-idio-shint-pyg.html-11"></a><span class="go">At the top i is 3</span>
<a name="python--ex33.sh-idio-shint-pyg.html-12"></a><span class="go">Numbers now:  [0, 1, 2, 3]</span>
<a name="python--ex33.sh-idio-shint-pyg.html-13"></a><span class="go">At the bottom i is 4</span>
<a name="python--ex33.sh-idio-shint-pyg.html-14"></a><span class="go">At the top i is 4</span>
<a name="python--ex33.sh-idio-shint-pyg.html-15"></a><span class="go">Numbers now:  [0, 1, 2, 3, 4]</span>
<a name="python--ex33.sh-idio-shint-pyg.html-16"></a><span class="go">At the bottom i is 5</span>
<a name="python--ex33.sh-idio-shint-pyg.html-17"></a><span class="go">At the top i is 5</span>
<a name="python--ex33.sh-idio-shint-pyg.html-18"></a><span class="go">Numbers now:  [0, 1, 2, 3, 4, 5]</span>
<a name="python--ex33.sh-idio-shint-pyg.html-19"></a><span class="go">At the bottom i is 6</span>
<a name="python--ex33.sh-idio-shint-pyg.html-20"></a><span class="go">The numbers:</span>
<a name="python--ex33.sh-idio-shint-pyg.html-21"></a><span class="go">0</span>
<a name="python--ex33.sh-idio-shint-pyg.html-22"></a><span class="go">1</span>
<a name="python--ex33.sh-idio-shint-pyg.html-23"></a><span class="go">2</span>
<a name="python--ex33.sh-idio-shint-pyg.html-24"></a><span class="go">3</span>
<a name="python--ex33.sh-idio-shint-pyg.html-25"></a><span class="go">4</span>
<a name="python--ex33.sh-idio-shint-pyg.html-26"></a><span class="go">5</span>
</pre></div></div>
<div class="section" id="study-drills">
<h1>Study Drills</h1>
<ol class="arabic simple">
<li>Convert this <tt class="docutils literal"><span class="pre">while-loop</span></tt> to a function that you can call, and replace <tt class="docutils literal">6</tt> in the test (<tt class="docutils literal">i &lt; 6</tt>) with a variable.</li>
<li>Use this function to rewrite the script to try different numbers.</li>
<li>Add another variable to the function arguments that you can pass in that lets you change the <tt class="docutils literal">+ 1</tt> on line 8 so you can change how much it increments by.</li>
<li>Rewrite the script again to use this function to see what effect that has.</li>
<li>Write it to use <tt class="docutils literal"><span class="pre">for-loops</span></tt> and <tt class="docutils literal">range</tt>.  Do you need the incrementor in the middle anymore?  What happens if you do not get rid of it?</li>
</ol>
<p>If at any time that you are doing this it goes crazy (it probably will), just hold down CTRL and press <tt class="docutils literal">c</tt> (CTRL-<tt class="docutils literal">c</tt>) and the program will abort.</p>
</div>
<div class="section" id="common-student-questions">
<h1>Common Student Questions</h1>
<dl class="docutils">
<dt>What's the difference between a <tt class="docutils literal"><span class="pre">for-loop</span></tt> and a <tt class="docutils literal"><span class="pre">while-loop</span></tt>?</dt>
<dd>A <tt class="docutils literal"><span class="pre">for-loop</span></tt> can only iterate (loop) &quot;over&quot; collections of things.  A <tt class="docutils literal"><span class="pre">while-loop</span></tt> can do any kind of iteration (looping) you want.  However, <tt class="docutils literal"><span class="pre">while-loops</span></tt> are harder to get right and you normally can get many things done with <tt class="docutils literal"><span class="pre">for-loops</span></tt>.</dd>
<dt>Loops are hard. How do I figure them out?</dt>
<dd>The main reason people don't understand loops is because they can't follow the &quot;jumping&quot; that the code does.  When a loop runs, it goes through its block of code, and at the end it jumps back to the top.  To visualize this, put print statements all over the loop printing out where in the loop Python is running and what the variables are set to at those points.  Write <tt class="docutils literal">print</tt> lines before the loop, at the top of the loop, in the middle, and at the bottom.  Study the output and try to understand the jumping that's going on.</dd>
</dl>
</div>
                <!-- RST ENDS -->
            </div>
        </div>

        <div class="row center-xs" id="buy">
            <div class="text-center col-xs-10 col-sm-5 col-md-4">
                <h2 class="section-title__small">Buy The Python 2 Course</h2>
                <p>
                When you buy directly from the author, Zed A. Shaw, you'll get a professional
                quality PDF and  hours of HD Video, all DRM-free and yours to download.
                </p>

                <p class="price-block">
                <span class="currency"><span class="prefix">$</span>29.<span class="suffix">99</span></span>
                </p>

                <a href="https://shop.learncodethehardway.org/access/buy/2/" class="btn btn-primary btn-full">Buy The Python 2 Course</a>
                <a href="https://shop.learncodethehardway.org/access/buy/9/" class="btn btn-primary btn-full">Pre-Order The Python 3 Course Instead</a>

                <p class="text-left btn-subtext">
                <small>Or, you can <a href="https://learnpythonthehardway.org/book/book_2.html">read Learn Python the Hard Way for free</a> right here, video lectures not included.</small>
                </p>

            </div>
            <div class="text-center col-xs-10 col-sm-5 col-md-4 col-sm-offset-1">

                <h2 class="section-title__small">Other Buying Options</h2>
                <a href="http://bit.ly/amznlpthw" class="btn btn-secondary btn-full">Buy on Amazon</a>
                <a href="http://bit.ly/informitlpthw" class="btn btn-secondary btn-full">Buy a hard copy from the Publisher</a>
                <a href="http://bit.ly/bnlpthw" class="btn btn-secondary btn-full">Buy a hard copy from Barnes &amp; Noble</a>

            </div>
        </div>
    </div>

    <div class="row center-xs" id="video_holder" style="display: none">
        <div class="col-xs-11 col-sm-10 col-md-9 col-lg-8">
            <div data-paydiv_product="2" id='paydiv'>
                No content available for this exercise.  You can view all available downloads at <a href="https://shop.learncodethehardway.org/customers/">your customer account page</a>.
            </div>
        </div>
    </div>
    </main>

</div>

<div class="row dark bottom-nav">
    <div class="col-xs text-left">
        <a href="ex33.html" class="prev" id='prev_link'><i class="icon-arrow-67"></i> <i class="icon icon-arrow-left"></i> Previous <span class="hide-xs show-sm-inline">Lesson</span></a>
    </div>
    <div class="col-xs text-right"><a href="ex33.html" class="next" id='next_link'>Next <span class="hide-xs show-sm-inline">Lesson</span> <i class="icon icon-arrow-right"></i></a>
    </div>
</div>
  </div>

<footer class="footer">
<div class="row center-xs">

    <div class="col-xs-11 col-sm-6 col-md-5 col-lg-5">
        <ul class="nav nav-inline">
            <li><h4><a href="https://learnpythonthehardway.org/learnpythonthehardway_default_2.html">Home</a></h4></li>
            <li><h4><a href="https://learncodethehardway.org/about/">About</a></h4></li>
            <li><h4><a href="https://learncodethehardway.org/contact/">Contact</a></h4></li>
        </ul>
        <div class="copyright text-left">
            <small class="text-muted">&copy; 2016 Zed A. Shaw. All rights reserved.</small>
        </div>
    </div>
    <div class="col-xs-11 col-sm-4 col-md-4 col-lg-3">
        <div class="social-media">
            <div class="classy-container">
                <a href="https://twitter.com/lzsthw" class="socicon-twitter"></a>
            </div>
        </div>
    </div>
</div>

</footer>
<script src="../js/scripts.min.js"></script>

<script src="javascripts/jquery.js"></script>
<script src="index.js"></script>
<script src="https://shop.learncodethehardway.org/static/jzed.js"></script>
<script src="https://shop.learncodethehardway.org/static/js/videojs/video.js"></script>
<link rel="stylesheet" href="https://shop.learncodethehardway.org/static/js/videojs/video-js.css">
<script src="https://shop.learncodethehardway.org/static/api/v1/paydiv.js"></script>
<script src="javascripts/app.js"></script>
<script src="javascripts/littools.js"></script>
<!-- Start of helpthw Zendesk Widget script -->
<script>/*<![CDATA[*/window.zEmbed||function(e,t){var n,o,d,i,s,a=[],r=document.createElement("iframe");window.zEmbed=function(){a.push(arguments)},window.zE=window.zE||window.zEmbed,r.src="javascript:false",r.title="",r.role="presentation",(r.frameElement||r).style.cssText="display: none",d=document.getElementsByTagName("script"),d=d[d.length-1],d.parentNode.insertBefore(r,d),i=r.contentWindow,s=i.document;try{o=s}catch(e){n=document.domain,r.src='javascript:var d=document.open();d.domain="'+n+'";void(0);',o=s}o.open()._l=function(){var o=this.createElement("script");n&&(this.domain=n),o.id="js-iframe-async",o.src=e,this.t=+new Date,this.zendeskHost=t,this.zEQueue=a,this.body.appendChild(o)},o.write('<body onload="document._l();">'),o.close()}("https://assets.zendesk.com/embeddable_framework/main.js","helpthw.zendesk.com");
/*]]>*/</script>
<!-- End of helpthw Zendesk Widget script -->
<script>
(function(i,s,o,g,r,a,m){i['GoogleAnalyticsObject']=r;i[r]=i[r]||function(){
 (i[r].q=i[r].q||[]).push(arguments)},i[r].l=1*new Date();a=s.createElement(o),
 m=s.getElementsByTagName(o)[0];a.async=1;a.src=g;m.parentNode.insertBefore(a,m)
 })(window,document,'script','https://www.google-analytics.com/analytics.js','ga');

ga('create', 'UA-24168052-1', 'auto');
ga('send', 'pageview');

</script>

</body>
</html>
